<script>
import { mapState, mapActions } from "vuex";
import { debounce } from "throttle-debounce";

export default {
  data() {
    return {
      isVisibleSearchVolunteers: false,

      search: "",

      invitedUsers: [],
    };
  },

  watch: {
    search() {
      this.debounceSearchUsers();
    },
  },

  computed: {
    ...mapState({
      participants: (state) => state.volunteers.participants,
      users: (state) => state.volunteers.users,
      members: (state) => state.volunteers.members,
    }),
  },

  methods: {
    ...mapActions({
      loadMembers: "volunteers/loadMembers",
      loadParticipants: "volunteers/loadParticipants",
      searchUsers: "volunteers/searchUsers",
      inviteUser: "volunteers/inviteUser",
    }),

    formatImagePath(path) {
      if (path !== null) {
        return path.url.full_size;
      } else {
        return require("../assets/logo.svg");
      }
    },

    debounceSearchUsers: debounce(1000, function () {
      this.searchUsers({
        search: this.search,
      });
    }),

    inviteUserRequest(userId) {
      this.inviteUser({ userId: userId }).then(() => {
        this.invitedUsers.push(userId);
      });
    },
  },

  mounted() {
    this.loadMembers();
    this.loadParticipants();
  },
};
</script>

<template>
  <div class="volunteers">
    <div class="volunteers__block block-wrapper">
      <v-dialog v-model="isVisibleSearchVolunteers" width="470">
        <template v-slot:activator="{ on, attrs }">
          <v-btn class="mr-2" color="info" v-bind="attrs" v-on="on">
            <v-icon left> mdi-magnify </v-icon>
            Поиск волонтеров
          </v-btn>
        </template>

        <v-card class="volunteer-search">
          <v-card-title class="text-h5 lighten-2 mb-8 pt-8 pb-0">
            Поиск участника
          </v-card-title>

          <v-card-text>
            <v-text-field
              v-model="search"
              outlined
              label="Поиск"
              prepend-inner-icon="mdi-magnify"
            ></v-text-field>

            <v-divider></v-divider>

            <div class="volunteer-search__list">
              <template v-if="users.length > 0">
                <div
                  v-for="user in users"
                  :key="user.id"
                  class="volunteer-search__item item"
                >
                  <div class="item__image">
                    <img src="../assets/logo.svg" width="20" alt="" />
                  </div>
                  <p class="item__name">{{ user.name }}</p>
                  <p class="item__place">
                    Возраст: <span>{{ user.age }} лет</span>
                  </p>
                  <p class="item__level">
                    Уровень: <span>{{ user.level }}</span>
                  </p>
                  <div class="item__button">
                    <v-btn
                      v-if="!invitedUsers.includes(user.id)"
                      icon
                      class="mx-2"
                      color="info"
                      @click="inviteUserRequest(user.id)"
                    >
                      <v-icon dark> mdi-plus </v-icon>
                    </v-btn>
                    <v-btn v-else icon class="mx-2" color="red" disabled>
                      <v-icon dark> mdi-check </v-icon>
                    </v-btn>
                  </div>
                </div>
              </template>

              <template v-else>
                <p class="mt-4">Ничего не найдено</p>
              </template>
            </div>
          </v-card-text>
        </v-card>
      </v-dialog>
    </div>

    <div class="volunteers__wrapper">
      <div class="volunteers__block block-wrapper volunteers-list">
        <h3 class="volunteers-list__title">Члены организации</h3>

        <div class="volunteers-list__list list">
          <div class="list__header">
            <p></p>
            <p>ФИО:</p>
            <p>Возраст:</p>
            <p>Уровень:</p>
            <p>Друзья:</p>
          </div>

          <template v-if="members.length > 0">
            <div class="list__wrapper">
              <div
                v-for="member in members"
                :key="member.id"
                class="list__volunteer volunteer"
              >
                <div class="volunteer__image">
                  <img
                    :src="formatImagePath(member.avatar)"
                    width="20"
                    alt=""
                  />
                </div>
                <p class="volunteer__name">{{ member.name }}</p>
                <p class="volunteer__place">
                  <span>{{ member.age }} лет</span>
                </p>
                <p class="volunteer__level">{{ member.level }}</p>
                <p class="volunteer__friends">-</p>
              </div>
            </div>
          </template>

          <template v-else>
            <p class="list__empty">Участники отсутствуют</p>
          </template>
        </div>
      </div>

      <div class="volunteers__block block-wrapper volunteers-list">
        <h3 class="volunteers-list__title">Участники ваших событий</h3>

        <div class="volunteers-list__list list">
          <div class="list__header">
            <p></p>
            <p>ФИО:</p>
            <p>Возраст:</p>
            <p>Уровень:</p>
            <p>Друзья:</p>
          </div>

          <template v-if="participants.length > 0">
            <div class="list__wrapper">
              <div
                v-for="participant in participants"
                :key="participant.id"
                class="list__volunteer list__volunteer_not-subscribed volunteer"
              >
                <div class="volunteer__image">
                  <img
                    :src="formatImagePath(participant.avatar)"
                    width="20"
                    alt=""
                  />
                </div>
                <p class="volunteer__name">{{ participant.name }}</p>
                <p class="volunteer__place">
                  <span>{{ participant.age }} лет</span>
                </p>
                <p class="volunteer__level">{{ participant.level }}</p>
                <p class="volunteer__friends">-</p>
                <div class="volunteer__button">
                  <v-btn
                    v-if="!invitedUsers.includes(participant.id)"
                    icon
                    class="mx-2"
                    color="info"
                    @click="inviteUserRequest(participant.id)"
                  >
                    <v-icon dark> mdi-plus </v-icon>
                  </v-btn>
                  <v-btn v-else icon class="mx-2" color="red" disabled>
                    <v-icon dark> mdi-check </v-icon>
                  </v-btn>
                </div>
              </div>
            </div>
          </template>

          <template v-else>
            <p class="list__empty">Участники отсутствуют</p>
          </template>
        </div>
      </div>
    </div>
  </div>
</template>

<style lang="scss" scoped>
.volunteers {
  height: 100%;
  overflow: auto;
  display: flex;
  flex-direction: column;
  align-items: center;
  padding: 100px 32px 60px;

  &__block {
    max-width: 570px;
    width: 100%;
    height: fit-content;
    padding: 16px;

    &:not(:last-child) {
      margin-bottom: 24px;
    }
  }

  &__wrapper {
    max-width: 570px;
    width: 100%;
  }

  .volunteers-list {
    max-height: 570px;
    overflow: auto;
    min-width: 100%;

    &__title {
      font-size: 22px;
      margin-bottom: 24px;
      line-height: 30px;
    }
  }

  .list {
    &__header {
      display: grid;
      grid-template-columns: 30px 176px 92px 80px 1fr;
      column-gap: 8px;
      margin-bottom: 12px;
      font-size: 14px;
      font-weight: 500;
    }

    &__volunteer {
      display: grid;
      align-items: center;
      grid-template-columns: 30px 176px 92px 80px 1fr;
      column-gap: 8px;

      &_not-subscribed {
        grid-template-columns: 30px 176px 92px 80px 66px 1fr;
      }

      &:not(:last-child) {
        border-bottom: 1px solid rgba(42, 49, 74, 0.2);
        padding-bottom: 8px;
        margin-bottom: 8px;
      }
    }

    &__empty {
      color: #5c5c5c;
    }
  }

  .volunteer {
    &__image {
      display: flex;
      align-items: center;
      max-width: 30px;
      height: 30px;

      img {
        border-radius: 4px;
        width: 100%;
        height: 100%;
      }
    }

    &__name {
      font-size: 14px;
      line-height: 18px;
      font-weight: 500;
    }

    &__place {
      font-size: 14px;
      font-weight: 400;
      color: #5c5c5c;

      span {
        font-weight: 600;
      }
    }

    &__level {
      font-size: 14px;
      font-weight: 600;
      color: #5c5c5c;
    }

    &__friends {
      font-size: 14px;
      font-weight: 600;
      color: #5c5c5c;
    }
  }
}
</style>
